import type { ModuleLoader, Resolver, ResolverCreatorOptions } from './types';
declare type Without<T, U> = {
    [P in Exclude<keyof T, keyof U>]?: never;
};
declare type XOR<T, U> = T | U extends object ? (Without<T, U> & U) | (Without<U, T> & T) : T | U;
/**
 * create module loader
 */
export declare function createLoader<Props extends Record<string, any> = any, Context = any>(options?: {
    globalVariables?: Record<string, any>;
} & XOR<{
    /**
     * remote module resolver, default to umd resolver
     */
    resolver?: Resolver<Context>;
}, ResolverCreatorOptions<WindowProxy>>): ModuleLoader<Props, Context>;
export {};
